package eu.univento.commons.player.warn;

import eu.univento.commons.player.uuid.NameFetcher;

import java.time.Instant;
import java.util.UUID;

/**
 * @author joethei
 * @version 1.0
 */
public class WarnData {

    private WarnReason reason;
    private UUID warner;
    private Instant date;
    private String proof;

    public WarnData(WarnReason reason, UUID warner, Instant date, String proof) {
        this.reason = reason;
        this.warner = warner;
        this.date = date;
        this.proof = proof;
    }

    public WarnReason getReason() {
        return reason;
    }

    public UUID getWarner() {
        return warner;
    }

    public Instant getDate() {
        return date;
    }

    public String getProof() {
        return proof;
    }

    public String getWarnerName() {
        if(warner == null)
            return "Auto Warn";
        return NameFetcher.getRequest(warner);
    }
}